package com.qiqiim.webserver.intercepter;

import com.qiqiim.webserver.util.JwtUtils;
import io.jsonwebtoken.Claims;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author shj
 * @date 2020-11-07 14:53
 */
public class LoginIntercepter implements HandlerInterceptor {
    @Override
    public boolean preHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o) throws Exception {
        if(httpServletRequest.getMethod().equals("OPTIONS"))
            return true;
        Cookie[] cookies = httpServletRequest.getCookies();
        String token = "";
        for (Cookie cookie:
             cookies) {
            if (cookie.getName().equals("ahrdxf_sys_token")) {
                token = cookie.getValue();
                break;
            }
        }
        System.out.println(token);
        if(StringUtils.isEmpty(token)){
            return false;
        }
        Claims claims = JwtUtils.parseToken(token);
        if(claims==null){
            return false;
        }
        String userId = (String) claims.get("userId");
        httpServletRequest.setAttribute("userId",userId);
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, ModelAndView modelAndView) throws Exception {

    }

    @Override
    public void afterCompletion(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, Exception e) throws Exception {

    }
}
