package com.qiqiim.webserver.util;

import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwt;
import io.jsonwebtoken.Jwts;
import sun.misc.BASE64Decoder;

import java.io.IOException;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.X509EncodedKeySpec;

/**
 * @author shj
 * @date 2020-11-07 14:44
 */
public class JwtUtils {

    private static final String PUBLIC_KEY_STR="MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDXAL185JGnX1OUgR6nv1BqMS00\n" +
            "fLRPg0O0ESffuc8TjuPkeRbhQjVcM1oyTLFAtuGba7AlwZChYxu7Aer5PvArSdJ5\n" +
            "a3ugF9/843IhEoE8LU1tFT9eOoc3dFi6Whtl8tylqXHTUN9z98GOazcqkwHmFk/T\n" +
            "xzG7vIbvfkLYP7aSCQIDAQAB";
    public static Claims parseToken(String token){
        PublicKey publicKey = getPublicKey();
        return Jwts.parser()
                .setSigningKey(publicKey)
                .parseClaimsJws(token)
                .getBody();
    }

    private static PublicKey getPublicKey() {
        PublicKey publicKey=null;
        byte[] keyBytes;
        try {
            keyBytes = (new BASE64Decoder()).decodeBuffer(PUBLIC_KEY_STR);
            X509EncodedKeySpec keySpec = new X509EncodedKeySpec(keyBytes);
            KeyFactory keyFactory = KeyFactory.getInstance("RSA");
            publicKey = keyFactory.generatePublic(keySpec);
        } catch (IOException e) {
            e.printStackTrace();
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (InvalidKeySpecException e) {
            e.printStackTrace();
        }
        return publicKey;
    }
}
